﻿package
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.ui.Mouse;

	public class Triangler extends Sprite
	{
		
		private var stack:Array;
		private var max:Number = 1;
		private var maxAngle:Number = Math.PI;
		
		public function Triangler()
		{
			stack = new Array();
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, upHandler);
		}
		
		private function downHandler(e:MouseEvent):void
		{
			stack[0] = new Point(e.stageX,e.stageY);
			stack[1] = new Point(e.stageX,e.stageY);
			var colorTr:uint=Math.random()*0xffffff;
			stack[2] = new uint(colorTr);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
		}
		
		private function upHandler(e:MouseEvent):void
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
		}
		
		private function moveHandler(e:MouseEvent):void
		{
			var rayonDiff : Number = 5 + Math.random()*10;
			var drawSpeed : Number = (Math.random()*10)/5;
			var alphaFill : Number = Math.cos(Math.abs((stack[1].y-stage.height)/(stack[1].x-stage.width))*drawSpeed);
			var rayon : Number = Math.cos(Math.abs((stack[1].y-stage.height)/(stack[1].x-stage.width))*drawSpeed)*rayonDiff;
			
			stack[1].x = e.stageX;
			stack[1].y = e.stageY;
			
			this.graphics.beginFill(stack[2],Math.cos(stack[1].x));
			if(Point.distance(stack[0],stack[1])>=max && checkAngle()%maxAngle<=1){
				stack[0].x = stack[1].x;
				stack[0].y = stack[1].y;
				this.graphics.beginFill(stack[2]*stack[2],Math.cos(stack[1].x));
			}
			
			this.graphics.drawCircle(stack[1].x,stack[1].y,rayon);
			this.graphics.endFill();
			
		}
		
		private function checkAngle():Number
		{
			var dx = stack[1].x - stack[0].x;
			var dy = stack[1].y - stack[0].y;
			
			var reponse = Math.round(Math.atan2(dx,dy)* 180 / Math.PI);
			//trace(reponse);
			return reponse;
		}
		
	}
}